if 0
draw_slices_buff:
; Procedure draws all pixels from slices buffer, with calculating
; its transparency/opaqe
; in: esi - counter buff every pixel - one byte
;     edi - pointers pointer buffer
;     edx - pointer to screen buffer
;     eax - screen size
     xor      ecx,ecx
  .again:
     push      ecx
     push      eax
     movzx     ecx,byte[esi]
     or        ecx,ecx
     jz        .skip
     mov       ebx,[edi]
     or        ebx,ebx
     jz        .skip
     xorps     xmm1,xmm1
     xorps     xmm2,xmm2
   .next_vox_pix:
     mov       eax,[ebx+ecx*8] ; + 4  - z coord
     shr       eax,24
     cmp       eax,255
     jnz       @f
     pxor      xmm2,xmm2
   @@:
     punpcklbw xmm0,[the_zero]
     punpcklwd xmm0,[the_zero]
     cvtdq2ps  xmm0,xmm0
     movhlps   xmm1,xmm0
     shufps    xmm1,xmm1,11000000b
     mulps     xmm0,xmm1    ; calc transparency
 ;
 ;  mozna to umiescic mnozenie/transparencje zalezne od glebokosci
 ;  here may be done transparency depth dependent
 ;

     addps     xmm2,xmm0
     sub       ecx,1
     jnz       @b

     cvtps2dq  xmm2,xmm2
     psrld     xmm2,1
     packssdw  xmm2,xmm2
     packuswb  xmm2,xmm2
     movd      [edx],xmm2
   .skip:
     add       edx,4
     add       esi,1
     add       edi,4
     pop       eax
     pop       ecx
     cmp       ecx,eax
     jnz       .again
ret

end if
do_variable_slices_ptr_buff:
; Procedure match every screen pixel with ptr, wich describes
; its depth history. If dword ptr = byte cnt = 0, not depth
; history, pixel has background color.
; in:  esi - counter buff
;      edi - ptr buff
;      eax - voxels depth history buff
;      ecx - count of all screen pixels
       jecxz  .end
     .again:
       movzx  edx,byte[esi]
       or     edx,edx
       jz     .zero
       mov    [edi],eax
       shl    edx,3    ; 8 bytes per voxel / pixel - col argb + z coord
       add    eax,edx
       jmp    .u_cnts
     .zero:
       mov    [edi],dword 0
     .u_cnts:
       add    esi,1
       add    edi,4
       sub    ecx,1
       jnz    .again
    .end:
ret

count_transparent_voxels:
; in:
;    edi - ptr to slices_cnt buffer
;	   this buff describes how many
;	   slices has every rendered pixel
;    eax - size x of screen
;    ebx - size y of scr
; out:
;    ecx - count of all transparent voxels
     push  ebp
   ;  int3
     mul   ebx
     xor   ebp,ebp
     shr   eax,2
     add   eax,1
     mov   esi,eax
   @@:
     movzx eax,byte[edi]
     movzx ebx,byte[edi+1]
     movzx ecx,byte[edi+2]
     movzx edx,byte[edi+3]
     add   ebp,eax
     add   ebp,ebx
     add   ebp,ecx
     add   ebp,edx
     add   edi,4
     sub   esi,1
     jnz   @b
     mov   ecx,ebp
     pop   ebp
ret

